/*-------------------------------------------------
  TestQTMusicLib.c
  Tests routines in QTMusicLib.c

  Web site for this library and other ones I've done:
  http://www.tunesmithy.co.uk/playmidilib/index.htm

  E-mail support@tunesmithy.co.uk
  (c) Robert Walker 2002
  -------------------------------------------------*/
#include "QTMusicLib.h"
#include <stdio.h>
#include <windows.h>
void RemoveLeadingAndTrailingWhiteSpace(char *sz);
// #define do_pb_test

int main()
{
 char szInput[10240];
 int i=0;
 printf("Test of QTMusic.dll.\n\n");
 {
	 HINSTANCE hQTJavaNative = LoadLibrary(TEXT("QTJavaNative.dll"));
	 if(hQTJavaNative==NULL)
  {
   printf("Couldn't find QTJavaNative.dll - probably means QT not installed");
   exit(0);
  }
 }
 printf("initialising Quick Time\n");
 if(QTMusic_Initialise_SME())
 {
  int iPitchBend=0;
  printf("Success!\n");
#ifdef do_pb_test
  printf("pitch bend test - you should now hear two identical notes:\n");
  printf("note 62 bent down by a tone and note 58 bent up by a tone.\n");
  QTMusic_SendMidiEvent(MIDI_SET_PATCH,0,0,0);
  QTMusic_SendMidiEvent(MIDI_SET_PATCH,1,0,0);
  QTMusic_SendMidiEvent(MIDI_PITCH_BEND,0,iPitchBend & 0x7F,iPitchBend >> 7);
  QTMusic_Delay (0.2);
  QTMusic_SendMidiEvent(MIDI_NOTE_ON,0,62,127);
  QTMusic_Delay (0.4);
  QTMusic_SendMidiEvent(MIDI_NOTE_ON,0,62,0);
  iPitchBend=16383;
  QTMusic_SendMidiEvent(MIDI_PITCH_BEND,1,iPitchBend & 0x7F,iPitchBend >> 7);
  QTMusic_Delay (0.2);
  QTMusic_SendMidiEvent(MIDI_NOTE_ON,1,58,127);
  QTMusic_Delay (0.4);
  QTMusic_SendMidiEvent(MIDI_NOTE_ON,1,58,0);
  printf("Press return to continue.\n");
  gets(szInput);
#endif
  {
   int nnotes_pb=4;
   printf("Multiple channel pitch bends test. You should now hear a rising scale:\n"
         "of notes from C to E, %d of them equally spaced. Each is played on a separate\n"
         "Quick time \"channel\" and you can have many more than 16 channels usually\n"
         "Seems to work up to 31 channels :-)\n\n"
         ,nnotes_pb
         );
   for(;;)
   {
    printf("Enter the number of notes to play from C to E, range 2 to 31, or \"next\"\n"
           "to go on to next test\n"
          );
    gets(szInput);
    RemoveLeadingAndTrailingWhiteSpace(szInput);
    if(strcmpi(szInput,"next")==0)
     break;
    nnotes_pb=atoi(szInput);
    nnotes_pb=max(2,min(MAX_QT_MIDI_CHANNELS,nnotes_pb));
    for(i=0;i<nnotes_pb;i++)
    {
     int ich=i;
     if(i>=NON_MELODIC_PERCUSSION_CHANNEL)
      ich++;
     QTMusic_SendMidiEvent(MIDI_SET_PATCH,ich,0,0);
     iPitchBend=(int)((16384*(long)i)/(nnotes_pb-1));
     if(i==nnotes_pb-1)
      iPitchBend=16383;
     QTMusic_SendMidiEvent(MIDI_PITCH_BEND,ich,iPitchBend & 0x7F,iPitchBend >> 7);
     /**
     QTMusic_Delay (0.3);
     QTMusic_SendMidiEvent(MIDI_NOTE_ON,ich,62,127);
     QTMusic_Delay (0.3);
     QTMusic_SendMidiEvent(MIDI_NOTE_OFF,ich,62,127);
     **/
    }
    QTMusic_Delay (0.3);
    /**/
    for(i=0;i<nnotes_pb;i++)
    {
     int ich=i;
     if(i>=NON_MELODIC_PERCUSSION_CHANNEL)
      ich++;
     /**
     iPitchBend=(int)((16384*(long)i)/(nnotes_pb-1));
     if(i==nnotes_pb-1)
      iPitchBend=16383;
      QTMusic_SendMidiEvent(MIDI_PITCH_BEND,ich,iPitchBend & 0x7F,iPitchBend >> 7);
      QTMusic_Delay (0.3);
     **/
     QTMusic_SendMidiEvent(MIDI_NOTE_ON,ich,62,127);
     QTMusic_Delay (0.1);
     QTMusic_SendMidiEvent(MIDI_NOTE_OFF,ich,62,127);
    }
    for(i=nnotes_pb-1;i>=0;i--)
    {
     int ich=i;
     if(i>=NON_MELODIC_PERCUSSION_CHANNEL)
      ich++;
     QTMusic_SendMidiEvent(MIDI_NOTE_ON,ich,62,127);
     QTMusic_Delay (0.1);
     QTMusic_SendMidiEvent(MIDI_NOTE_OFF,ich,62,127);
    }
    /**/
   }
  }
#define NON_MELODIC_PERCUSSION_CHANNEL 9
  printf("Non Melodic percussion test - you should now hear percussion:\n"
        "- each instrument in turn from 35 to 81\n"
        );
  {
   int i=0;
   for(i=35;i<=81;i++)
   {
    char c=0;
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,NON_MELODIC_PERCUSSION_CHANNEL,i,127);
    printf("Non Melodic .Perc %d\n"
          "Press return for next instrument or Y to break.\n"
          ,i
          );
    gets(szInput);
    RemoveLeadingAndTrailingWhiteSpace(szInput);
    if(szInput[0]=='y'||szInput[0]=='Y')
     break;
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,NON_MELODIC_PERCUSSION_CHANNEL,i,0);
   }
  }
  {
   int i=0;
   for(i=35;i<=81;i++)
   {
    char c=0;
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,NON_MELODIC_PERCUSSION_CHANNEL,i,127);
    printf("Non Melodic .Perc %d\n"
          "Press return for next instrument or Y to break.\n"
          ,i
          );
    gets(szInput);
    RemoveLeadingAndTrailingWhiteSpace(szInput);
    if(szInput[0]=='y'||szInput[0]=='Y')
     break;
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,NON_MELODIC_PERCUSSION_CHANNEL,i,0);
   }
  }
  printf("And now all of them at once!\n"
        );
  printf("Press return to continue.\n");
  getchar();
  {
   int i=0;
   for(i=35;i<=81;i++)
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,NON_MELODIC_PERCUSSION_CHANNEL,i,127);
   QTMusic_Delay (1);
   for(i=35;i<=81;i++)
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,NON_MELODIC_PERCUSSION_CHANNEL,i,0);
  }
  {
   int i=0,iPatch=0;
   for(iPatch=0;iPatch<=127;iPatch++)
   {
    char c=0;
    QTMusic_SendMidiEvent(MIDI_SET_PATCH,0,iPatch,0);
    printf("Melodic instrument %d\n"
          "Press return for next instrument or Y to break.\n"
          ,iPatch
          );
    for(i=48;i<=72;i++)
    {
     QTMusic_SendMidiEvent(MIDI_NOTE_ON,0,i,127);
     QTMusic_Delay (0.05);
     QTMusic_SendMidiEvent(MIDI_NOTE_OFF,0,i,127);
    }
    gets(szInput);
    RemoveLeadingAndTrailingWhiteSpace(szInput);
    if(szInput[0]=='y'||szInput[0]=='Y')
     break;
    QTMusic_SendMidiEvent(MIDI_NOTE_ON,0,i,0);
   }
  }
  QTMusic_CleanUp_SME();
  printf("finished - press return to exit.\n");
  getchar();
 }
 else
  printf("Couldn't initialise!\n");

 // QTMusic_PlaySomeBentNotes();
 return 0;
}

void RemoveLeadingAndTrailingWhiteSpace(char *sz)
{
 int i=0,ipos=0;
 BOOL bWhiteSpaceSoFar=TRUE;
 for(i=strlen(sz);i>=0;i--)
 {
  char c=sz[i];
  if(!isspace(c))
   bWhiteSpaceSoFar=FALSE;
  // remove trailing white spaces
  if(bWhiteSpaceSoFar)
   sz[i]='\0';
 }
 bWhiteSpaceSoFar=TRUE;
 for(i=0;sz[i];i++)
 {
  char c=sz[i];
  if(!isspace(c))
   bWhiteSpaceSoFar=FALSE;
  if(!bWhiteSpaceSoFar)
   sz[ipos++]=c;
 }
 sz[ipos]='\0';
}

